#include "xmegamp3_objects.h"
#include "xmegamp3_resources.h"
#include "built_in.h"

// Extern memory interface
// MMC/SD Connections
sbit Mmc_Chip_Select at PORTF_OUT.B5;
sbit Mmc_Chip_Select_Direction at PORTF_DIR.B5;
// end of MMC/SD
// TFT Get Data globals
unsigned long currentSector = -1, res_file_size;
// end of TFT Get Data
// End of extern memory interface


// TFT module connections
char TFT_DataPort at PORTK_OUT;
sbit TFT_RST at PORTJ_OUT.B1;
sbit TFT_BLED at PORTC_OUT.B4;
sbit TFT_RS at PORTJ_OUT.B4;
sbit TFT_CS at PORTJ_OUT.B5;
sbit TFT_RD at PORTJ_OUT.B2;
sbit TFT_WR at PORTJ_OUT.B3;
char TFT_DataPort_Direction at PORTK_DIR;
sbit TFT_RST_Direction at PORTJ_DIR.B1;
sbit TFT_BLED_Direction at PORTC_DIR.B4;
sbit TFT_RS_Direction at PORTJ_DIR.B4;
sbit TFT_CS_Direction at PORTJ_DIR.B5;
sbit TFT_RD_Direction at PORTJ_DIR.B2;
sbit TFT_WR_Direction at PORTJ_DIR.B3;
// End TFT module connections

// Touch Panel module connections
sbit DRIVEX_LEFT at PORTA_OUT.B2;
sbit DRIVEX_RIGHT at PORTQ_OUT.B2;
sbit DRIVEY_UP at PORTQ_OUT.B3;
sbit DRIVEY_DOWN at PORTA_OUT.B1;
sbit DRIVEX_LEFT_DIRECTION at PORTA_DIR.B2;
sbit DRIVEX_RIGHT_DIRECTION at PORTQ_DIR.B2;
sbit DRIVEY_UP_DIRECTION at PORTQ_DIR.B3;
sbit DRIVEY_DOWN_DIRECTION at PORTA_DIR.B1;
// End Touch Panel module connections

// Global variables
unsigned int Xcoord, Ycoord;
const ADC_THRESHOLD = 900;
char PenDown;
void *PressedObject;
int PressedObjectType;
unsigned int caption_length, caption_height;
unsigned int display_width, display_height;

int _object_count;
unsigned short object_pressed;
TImage *local_image;
TImage *exec_image;
int image_order;
TBox_Round *local_round_box;
TBox_Round *exec_round_box;
int box_round_order;


char* TFT_Get_Data(unsigned long offset, unsigned int count, unsigned int *num) {
unsigned long start_sector;
unsigned int pos;

  start_sector = Mmc_Get_File_Write_Sector() + offset/512;
  pos = (unsigned long)offset%512;

  if(start_sector == currentSector+1) {
    Mmc_Multi_Read_Sector(f16_sector.fSect);
    currentSector = start_sector;
  } else if (start_sector != currentSector) {
    if(currentSector != -1)
      Mmc_Multi_Read_Stop();
    Mmc_Multi_Read_Start(start_sector);
    Mmc_Multi_Read_Sector(f16_sector.fSect);
    currentSector = start_sector;
  }

  if(count>512-pos)
    *num = 512-pos;
  else
    *num = count;

  return f16_sector.fSect+pos;
}
static void InitializeTouchPanel() {
  TFT_Init(320, 240);
  TFT_Set_Ext_Buffer(TFT_Get_Data);

}


/////////////////////////
  TScreen*  CurrentScreen;

  TScreen                Screen1;
  TImage               Image1;
  TBox_Round             BoxRound1;
  TImage                 * const code far Screen1_Images[1]=
         {
         &Image1               
         };
  TBox_Round             * const code far Screen1_Boxes_Round[1]=
         {
         &BoxRound1            
         };




static void InitializeObjects() {
  Screen1.Color                     = 0xC618;
  Screen1.Width                     = 320;
  Screen1.Height                    = 240;
  Screen1.ImagesCount               = 1;
  Screen1.Images                    = Screen1_Images;
  Screen1.Boxes_RoundCount          = 1;
  Screen1.Boxes_Round               = Screen1_Boxes_Round;
  Screen1.ObjectsCount              = 2;


  Image1.OwnerScreen     = &Screen1;
  Image1.Order          = 0;
  Image1.Left           = 0;
  Image1.Top            = 0;
  Image1.Width          = 320;
  Image1.Height         = 240;
  Image1.Picture_Type        = 1;
  Image1.Picture_Ratio  = 1;
  Image1.Picture_Name   = test_jpg;
  Image1.Visible        = 1;
  Image1.Active         = 1;
  Image1.OnUpPtr         = 0;
  Image1.OnDownPtr       = 0;
  Image1.OnClickPtr      = 0;
  Image1.OnPressPtr      = 0;

  BoxRound1.OwnerScreen     = &Screen1;
  BoxRound1.Order           = 1;
  BoxRound1.Left            = 24;
  BoxRound1.Top             = 78;
  BoxRound1.Width           = 140;
  BoxRound1.Height          = 100;
  BoxRound1.Pen_Width       = 1;
  BoxRound1.Pen_Color       = 0x0000;
  BoxRound1.Visible         = 1;
  BoxRound1.Active          = 1;
  BoxRound1.Transparent     = 1;
  BoxRound1.Gradient        = 1;
  BoxRound1.Gradient_Orientation    = 0;
  BoxRound1.Gradient_Start_Color    = 0xFFFF;
  BoxRound1.Gradient_End_Color      = 0xC618;
  BoxRound1.Color           = 0xC618;
  BoxRound1.PressColEnabled     = 1;
  BoxRound1.Press_Color     = 0x8410;
  BoxRound1.Corner_Radius      = 3;
  BoxRound1.OnUpPtr         = 0;
  BoxRound1.OnDownPtr       = 0;
  BoxRound1.OnClickPtr      = 0;
  BoxRound1.OnPressPtr      = 0;
}

static char IsInsideObject (unsigned int X, unsigned int Y, unsigned int Left, unsigned int Top, unsigned int Width, unsigned int Height) { // static
  if ( (Left<= X) && (Left+ Width - 1 >= X) &&
       (Top <= Y)  && (Top + Height - 1 >= Y) )
    return 1;
  else
    return 0;
}


#define GetImage(index)               CurrentScreen->Images[index]
#define GetBox_Round(index)           CurrentScreen->Boxes_Round[index]

 void DeleteTrailingSpaces(char* str){
   char i;
   i = 0;
   while(1) {
   if(str[0] == ' ') {
      for(i = 0; i < strlen(str); i++) {
       str[i] = str[i+1];
      }
   }
   else
     break;
  }
 }

void DrawImage(TImage *AImage) {
  if (AImage->Visible) {
    TFT_Ext_Image(AImage->Left, AImage->Top, AImage->Picture_Name, AImage->Picture_Ratio);
  }
}

void DrawRoundBox(TBox_Round *Around_box) {
    if (Around_box->Visible == 1) {
      if (object_pressed == 1) {
        object_pressed = 0;
        TFT_Set_Brush(Around_box->Transparent, Around_box->Press_Color, Around_box->Gradient, Around_box->Gradient_Orientation,
                      Around_box->Gradient_End_Color, Around_box->Gradient_Start_Color);
      }
      else {
        TFT_Set_Brush(Around_box->Transparent, Around_box->Color, Around_box->Gradient, Around_box->Gradient_Orientation,
                      Around_box->Gradient_Start_Color, Around_box->Gradient_End_Color);
      }
      TFT_Set_Pen(Around_box->Pen_Color, Around_box->Pen_Width);
      if (Around_box->Height > Around_box->Width) {
        TFT_Rectangle_Round_Edges(Around_box->Left + 1, Around_box->Top + 1,
          Around_box->Left + Around_box->Width - 2,
          Around_box->Top + Around_box->Height - 2, Around_box->Corner_Radius);
      }
      else
        {
          TFT_Rectangle_Round_Edges(Around_box->Left + 1, Around_box->Top + 1,
            Around_box->Left + Around_box->Width - 2,
            Around_box->Top + Around_box->Height - 2, Around_box->Corner_Radius);
        }
    }
}

void DrawScreen(TScreen *aScreen) {
 int order;
  unsigned short image_idx;
  TImage *local_image;
  unsigned short round_box_idx;
  TBox_Round *local_round_box;
  char save_bled, save_bled_direction;

  object_pressed = 0;
  order = 0;
  image_idx = 0;
  round_box_idx = 0;
  CurrentScreen = aScreen;

  if ((display_width != CurrentScreen->Width) || (display_height != CurrentScreen->Height)) {
    save_bled = TFT_BLED;
    save_bled_direction = TFT_BLED_Direction;
    TFT_BLED_Direction = 1;
    TFT_BLED           = 0;
    TFT_Init(CurrentScreen->Width, CurrentScreen->Height);
    TFT_Set_Ext_Buffer(TFT_Get_Data);
    TFT_Fill_Screen(CurrentScreen->Color);
    display_width = CurrentScreen->Width;
    display_height = CurrentScreen->Height;
    TFT_BLED           = save_bled;
    TFT_BLED_Direction = save_bled_direction;
  }
  else
    TFT_Fill_Screen(CurrentScreen->Color);


  while (order < CurrentScreen->ObjectsCount) {
    if (round_box_idx < CurrentScreen->Boxes_RoundCount) {
      local_round_box = GetBox_Round(round_box_idx);
      if (order == local_round_box->Order) {
        round_box_idx++;
        order++;
        DrawRoundBox(local_round_box);
      }
    }

    if (image_idx  < CurrentScreen->ImagesCount) {
      local_image = GetImage(image_idx);
      if (order == local_image->Order) {
        image_idx++;
        order++;
        DrawImage(local_image);
      }
    }

  }
}

void Init_MCU() {
  OSC_CTRL = 0x02;          // 32MHz internal RC oscillator
  while(RC32MRDY_bit == 0)
  ;
  CPU_CCP = 0xD8;
  CLK_CTRL = 1;             // set system clock to 32MHz internal RC oscillator
  TFT_BLED_Direction = 1;
  TFT_BLED = 1;
  // TP_TFT_Rotate_180(0);
}

void Init_Ext_Mem() {
  // Initialize SPI
  SPIC_Init_Advanced(_SPI_MASTER,_SPI_FCY_DIV128, _SPI_CLK_LO_LEADING);
  Delay_ms(10);

  // Initialize MMC
  if (!Mmc_Fat_Init()) {
    // Reinitialize SPI at higher speed
    SPIC_Init_Advanced(_SPI_MASTER,_SPI_FCY_DIV4, _SPI_CLK_LO_LEADING);

    // Open resource file for read
    Mmc_Fat_Assign("xmegamp3.RES", 0);
    Mmc_Fat_Reset(&res_file_size);
  }
}

void Start_TP() {
  Init_MCU();

  Init_Ext_Mem();

  InitializeTouchPanel();

  InitializeObjects();
  display_width = Screen1.Width;
  display_height = Screen1.Height;
  DrawScreen(&Screen1);
}
